package bin;

import lib.CLIAppBase;
import kernel.peripherals.Peripherals.Peripheral;

using tink.CoreApi;

@:build(macros.Binstore.includeBin("Redstone", ["redstone", "rs"]))
class Redstone extends CLIAppBase {
	public function new() {
		registerSyncSubcommand("on", (args) -> {
			Peripheral.getRedstone(args.getString("side")).setOutput(true);
			return true;
		}, [Side("side")]);

		registerSyncSubcommand("off", (args) -> {
			Peripheral.getRedstone(args.getString("side")).setOutput(false);
			return true;
		}, [Side("side")]);

		registerSyncSubcommand("get", (args) -> {
			var value = Peripheral.getRedstone(args.getString("side")).getAnalogInput();
			handle.write("Analog input: " + value);
			return true;
		}, [Side("side")]);
	}
}
