package kernel.turtle;

using tink.CoreApi;

/**
	The slot nummber for turtle inventory. 0 based. Assured to be in range.
**/
abstract TurtleSlot(Int) to Int {
	public function new(i:Int) {
		if (i >= 0 && i < Turtle.MAX_SLOTS) {
			this = i;
		} else {
			throw new Error("Slot not in range: " + i);
		}
	}

	@:from
	public static function fromInt(i:Int) {
		return new TurtleSlot(i);
	}

	@:allow(kernel.turtle)
	private inline function toCCSlot():Int {
		return this + 1;
	}
}
