package lib;

import kernel.http.HTTPRequest.Http;
import lua.TableTools;
import kernel.log.Log;
import lua.NativeStringTools;
import lib.ui.Canvas;
import cc.ComputerCraft;
#if webconsole
import cc.HTTP;
import kernel.net.Net;
import kernel.log.LogLine;
#end

class Debug {
	public static function printBuildInfo() {
		Log.debug("Commit: " + BuildInfo.getGitCommitHash());

		Log.debug("Build time: " + BuildInfo.buildTime().toString());

		Log.debug("CC/MC version:" + ComputerCraft._HOST);
	}

	public static function printCanvasToConsole(canvas:Canvas) {
		var lines:Array<String> = [];

		for (pos => pixel in canvas) {
			if (lines[pos.y] == null) {
				lines[pos.y] = "";
			}

			if (lines[pos.y].length < pos.x) {
				lines[pos.y] += NativeStringTools.rep(" ", pos.x - lines[pos.y].length);
			}

			lines[pos.y] = lines[pos.y].substr(0, pos.x) + pixel.char + lines[pos.y].substr(pos.x + 1);
		}

		Log.debug("\n" + lines.join("\n"));
	}

	public static function printArgs(?pos:haxe.PosInfos) {
		var info = lua.Debug.getinfo(2);

		var args = "";

		for (i in 1...info.nparams + 1) {
			var t = TableTools.pack(lua.Debug.getlocal(2, i));
			if (t[1] == "self") {
				continue;
			}

			if (args != "") {
				args += ", ";
			}

			args += t[1] + ":" + t[2];
		}

		Log.debug('${pos.className}.${pos.methodName}($args)');
	}

	#if Debug
	public static function printKernelEventsCount() {
		KernelEvents.printListenerCount();
	}
	#end

	#if webconsole
	public static function logToWebconsole(line:LogLine) {
		Http.request('http://127.0.0.1:8080/log/${Net.networkID}/${line.level.getIndex()}', '[${line.origin}] ${line.message}').eager();
	}
	#end
}
