package lib.turtle.planner;

import kernel.turtle.Turtle;

using tink.CoreApi;

class Executer {
	public function new() {}

	public function execute(action:Action) {
		var r = translate(action);
		switch r {
			case Failure(failure):
				throw new Error(failure); // I think that this a valid place to use exeptions.
			default:
		}
	}

	private function translate(action:Action):Outcome<Noise, String> {
		switch (action) {
			case Forward:
				return Turtle.forward();
			case Back:
				return Turtle.back();
			case Up:
				return Turtle.up();
			case Down:
				return Turtle.down();
			case TurnLeft:
				return Turtle.turnLeft();
			case TurnRight:
				return Turtle.turnRight();
			case Clear(dir):
				return Turtle.digEmpty(dir);
			case FullTunnel:
				return Helper.combine([Turtle.digEmpty.bind(Front), Turtle.forward, Turtle.digEmpty.bind(Down)]);
			case HalfTunnel:
				return Helper.combine([Turtle.digEmpty.bind(Front), Turtle.down, Turtle.digEmpty.bind(Front), Turtle.up]);
		}
	}
}
